Index: trunk/NEMO/OPA_SRC/TRD/trdmld.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 503)
@@ -642,213 +709,218 @@
       !!      from ocean surface down to control surface (NetCDF output)
       !!
-      !! ** Method/usage :
-      !!
-      !! History :
-      !!        !  95-04  (J. Vialard)  Original code
-      !!        !  97-02  (E. Guilyardi)  Adaptation global + base cmo
-      !!        !  99-09  (E. Guilyardi)  Re-writing + netCDF output
-      !!   8.5  !  02-06  (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
       !!----------------------------------------------------------------------
       !! * Local declarations
-      INTEGER :: ilseq
+      INTEGER :: ilseq, jl
 
       REAL(wp) ::   zjulian, zsto, zout
 
-      CHARACTER (LEN=21) ::   &
+      CHARACTER (LEN=21) ::    &
          clold ='OLD'        , & ! open specifier (direct access files)
          clunf ='UNFORMATTED', & ! open specifier (direct access files)
          clseq ='SEQUENTIAL'     ! open specifier (direct access files)
-      CHARACTER (LEN=40) ::   clhstnam
       CHARACTER (LEN=40) ::   clop
-      CHARACTER (LEN=12) ::   clmxl
-
-      NAMELIST/namtrd/ ntrd, nctls
+      CHARACTER (LEN=12) ::   clmxl, cltu, clsu
+
       !!----------------------------------------------------------------------
 
-      !  ===================
-      !   I. initialization
-      !  ===================
-
-      ! Open specifier
-      ilseq  = 1
-      idebug = 0      ! set it to 1 in case of problem to have more print
-      icount = 1      
-      ionce  = 1
-
-      ! namelist namtrd : trend diagnostic
-      REWIND( numnam )
-      READ  ( numnam, namtrd )
+      ! ======================================================================
+      ! I. initialization
+      ! ======================================================================
 
       IF(lwp) THEN
-         WRITE(numout,*) ' '
-         WRITE(numout,*) 'trd_mld_init: mixed layer heat & freshwater budget trends'
-         WRITE(numout,*) '~~~~~~~~~~~~~'
-         WRITE(numout,*) ' '
-         WRITE(numout,*) '          Namelist namtrd : '
-         WRITE(numout,*) '             control surface for trends      nctls = ',nctls
-         WRITE(numout,*) ' '
-      ENDIF
-
-      ! cumulated trends array init
+         WRITE(numout,*)
+         WRITE(numout,*) ' trd_mld_init : Mixed-layer trends'
+         WRITE(numout,*) ' ~~~~~~~~~~~~~'
+         WRITE(numout,*) '                namelist namtrd read in trd_mod_init                        '
+         WRITE(numout,*)
+      END IF
+
+      ! I.1 Check consistency of user defined preferences
+      ! -------------------------------------------------
+
+      IF( ( lk_trdmld ) .AND. ( MOD( nitend, ntrd ) /= 0 ) ) THEN
+         WRITE(numout,cform_err)
+         WRITE(numout,*) '                Your nitend parameter, nitend = ', nitend
+         WRITE(numout,*) '                is no multiple of the trends diagnostics frequency        '
+         WRITE(numout,*) '                          you defined, ntrd   = ', ntrd
+         WRITE(numout,*) '                This will not allow you to restart from this simulation.  '
+         WRITE(numout,*) '                You should reconsider this choice.                        ' 
+         WRITE(numout,*) 
+         WRITE(numout,*) '                N.B. the nitend parameter is also constrained to be a     '
+         WRITE(numout,*) '                multiple of the sea-ice frequency parameter (typically 5) '
+         nstop = nstop + 1
+      END IF
+
+      IF( ( lk_trdmld ) .AND. ( n_cla == 1 ) ) THEN
+         WRITE(numout,cform_war)
+         WRITE(numout,*) '                You set n_cla = 1. Note that the Mixed-Layer diagnostics  '
+         WRITE(numout,*) '                are not exact along the corresponding straits.            '
+         nwarn = nwarn + 1
+      END IF
+
+      ! I.2 Initialize arrays to zero or read a restart file
+      ! ----------------------------------------------------
+
       nmoymltrd = 0
-      tmltrdm(:,:) = 0.e0
-      smltrdm(:,:) = 0.e0
-
-      !  read control surface from file ctlsurf_idx
-
+
+      !     ... temperature ...                  ... salinity ...
+      tml            (:,:)   = 0.e0    ;    sml            (:,:)   = 0.e0     ! inst.
+      tmltrdm        (:,:)   = 0.e0    ;    smltrdm        (:,:)   = 0.e0
+      tmlatfm        (:,:)   = 0.e0    ;    smlatfm        (:,:)   = 0.e0
+      tml_sum        (:,:)   = 0.e0    ;    sml_sum        (:,:)   = 0.e0     ! mean
+      tmltrd_sum     (:,:,:) = 0.e0    ;    smltrd_sum     (:,:,:) = 0.e0
+      tmltrd_csum_ln (:,:,:) = 0.e0    ;    smltrd_csum_ln (:,:,:) = 0.e0
+
+      rmld           (:,:)   = 0.e0            
+      rmld_sum       (:,:)   = 0.e0
+
+      IF( ln_rstart .AND. ln_trdmld_restart ) THEN
+         CALL trd_mld_rst_read
+      ELSE
+         !     ... temperature ...                  ... salinity ...
+         tmlb           (:,:)   = 0.e0    ;    smlb           (:,:)   = 0.e0  ! inst.
+         tmlbb          (:,:)   = 0.e0    ;    smlbb          (:,:)   = 0.e0  
+         tmlbn          (:,:)   = 0.e0    ;    smlbn          (:,:)   = 0.e0  
+         tml_sumb       (:,:)   = 0.e0    ;    sml_sumb       (:,:)   = 0.e0  ! mean
+         tmltrd_csum_ub (:,:,:) = 0.e0    ;    smltrd_csum_ub (:,:,:) = 0.e0
+         tmltrd_atf_sumb(:,:)   = 0.e0    ;    smltrd_atf_sumb(:,:)   = 0.e0  
+      END IF
+
+      ilseq  = 1   ;   icount = 1   ;   ionce  = 1                            ! open specifier
+
+      ! I.3 Read control surface from file ctlsurf_idx
+      ! ----------------------------------------------
+ 
       IF( nctls == 1 ) THEN
-         clname ='ctlsurf_idx'
-         CALL ctlopn(numbol,clname,clold,clunf,clseq,   &
-              ilseq,numout,lwp,1)
-         REWIND (numbol)
-         READ(numbol) nbol
-      ENDIF
-
-
-      IF( idebug /= 0 ) THEN
-         WRITE(numout,*) ' debuging trd_mld_init: 0. done '  
-         CALL FLUSH(numout)
-      ENDIF
-
-      !  ===================================
-      !   II. netCDF output initialization
-      !  ===================================
+         clname = 'ctlsurf_idx'
+         CALL ctlopn( numbol, clname, clold, clunf, clseq, ilseq, numout, lwp, 1 )
+         REWIND( numbol )
+         READ  ( numbol ) nbol
+      END IF
+
+      ! ======================================================================
+      ! II. netCDF output initialization
+      ! ======================================================================
 
 #if defined key_dimgout 
-
+      ???
 #else
-      !     clmxl = legend root for netCDF output
-      IF( nctls == 0 ) THEN
-         ! control surface = mixed-layer with density criterion 
-         ! (array nmln computed in zdfmxl.F90)
-         clmxl = 'Mixed Layer '
-      ELSE IF( nctls == 1 ) THEN
-         ! control surface = read index from file 
+      ! clmxl = legend root for netCDF output
+      IF( nctls == 0 ) THEN      ! control surface = mixed-layer with density criterion
+         clmxl = 'Mixed Layer '  !                   (array nmln computed in zdfmxl.F90)
+      ELSE IF( nctls == 1 ) THEN ! control surface = read index from file 
          clmxl = '      Bowl '
-      ELSE IF( nctls >= 2 ) THEN
-         ! control surface = model level
-         WRITE(clmxl,'(A9,I2,1X)') 'Levels 1-', nctls
-      ENDIF
-
-      !-----------------------------------------
+      ELSE IF( nctls >= 2 ) THEN ! control surface = model level
+         WRITE(clmxl,'(A10,I2,1X)') 'Levels 1 -', nctls
+      END IF
+
       ! II.1 Define frequency of output and means
       ! -----------------------------------------
-
-#if defined key_diainstant
-      zsto = nwrite*rdt
-      clop ="inst(x)"
-#else
-      zsto = rdt
-      clop ="ave(x)"
-#endif
-      zout = nwrite*rdt
-
-      IF(lwp) WRITE (numout,*) ' trdmld_ncinit: netCDF initialization'
+#  if defined key_diainstant
+      IF( .NOT. ln_trdmld_instant ) THEN
+         CALL ctl_stop( 'trd_mld : this was never checked. Comment this line to proceed...' )
+      END IF
+      zsto = ntrd * rdt
+      clop ="inst(only(x))"
+#  else
+      IF( ln_trdmld_instant ) THEN
+         zsto = rdt                 ! inst. diags : we use IOIPSL time averaging
+      ELSE
+         zsto = ntrd * rdt          ! mean  diags : we DO NOT use any IOIPSL time averaging
+      END IF
+      clop ="ave(only(x))"
+#  endif
+      zout = ntrd * rdt
+
+      IF(lwp) WRITE (numout,*) '                netCDF initialization'
 
       ! II.2 Compute julian date from starting date of the run
-      ! ------------------------
-
+      ! ------------------------------------------------------
       CALL ymds2ju( nyear, nmonth, nday, 0.e0, zjulian )
-      IF (lwp) WRITE(numout,*)' '  
-      IF (lwp) WRITE(numout,*)' Date 0 used :',nit000   &
-           ,' YEAR ', nyear,' MONTH ', nmonth,' DAY ', nday   &
-           ,'Julian day : ', zjulian
+      IF(lwp) WRITE(numout,*)' '  
+      IF(lwp) WRITE(numout,*)'                Date 0 used :',nit000,    &
+         &                   ' YEAR ', nyear,' MONTH '      , nmonth,   &
+         &                   ' DAY ' , nday, 'Julian day : ', zjulian
 
 
       ! II.3 Define the T grid trend file (nidtrd)
-      ! ---------------------------------
-
-      CALL dia_nam( clhstnam, nwrite, 'trends' )                  ! filename
+      ! ------------------------------------------
+      !-- Define long and short names for the NetCDF output variables
+      !       ==> choose them according to trdmld_oce.F90 <==
+
+      ctrd(jpmld_xad,1) = " Zonal advection"                  ;   ctrd(jpmld_xad,2) = "_xad"
+      ctrd(jpmld_yad,1) = " Meridional advection"             ;   ctrd(jpmld_yad,2) = "_yad"
+      ctrd(jpmld_zad,1) = " Vertical advection"               ;   ctrd(jpmld_zad,2) = "_zad"
+      ctrd(jpmld_ldf,1) = " Lateral diffusion"                ;   ctrd(jpmld_ldf,2) = "_ldf"
+      ctrd(jpmld_for,1) = " Forcing"                          ;   ctrd(jpmld_for,2) = "_for"
+      ctrd(jpmld_zdf,1) = " Vertical diff. (Kz)"              ;   ctrd(jpmld_zdf,2) = "_zdf"
+      ctrd(jpmld_bbc,1) = " Geothermal flux"                  ;   ctrd(jpmld_bbc,2) = "_bbc"
+      ctrd(jpmld_bbl,1) = " Adv/diff. Bottom boundary layer"  ;   ctrd(jpmld_bbl,2) = "_bbl"
+      ctrd(jpmld_dmp,1) = " Tracer damping"                   ;   ctrd(jpmld_dmp,2) = "_dmp"
+      ctrd(jpmld_npc,1) = " Non penetrative convec. adjust."  ;   ctrd(jpmld_npc,2) = "_npc"
+      ctrd(jpmld_atf,1) = " Asselin time filter"              ;   ctrd(jpmld_atf,2) = "_atf"
+                                                                  
+      !-- Create a NetCDF file and enter the define mode 
+      CALL dia_nam( clhstnam, ntrd, 'trends' )
       IF(lwp) WRITE(numout,*) ' Name of NETCDF file ', clhstnam
-      CALL histbeg( clhstnam, jpi, glamt, jpj, gphit,1, jpi,   &  ! Horizontal grid : glamt and gphit
-         &          1, jpj, 0, zjulian, rdt, nh_t, nidtrd, domain_id=nidom )
-
-      ! Declare output fields as netCDF variables
-
-      ! Mixed layer Depth
-      CALL histdef( nidtrd, "somlttml", clmxl//"Depth"              , "m"   ,   &  ! hmlp
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-
-      ! Temperature
-      CALL histdef( nidtrd, "somltemp", clmxl//"Temperature"        , "C"   ,   &  ! ???
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      ! Temperature trends
-      CALL histdef( nidtrd, "somlttto", clmxl//"T Total"             , "C/s",   &  ! total
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zout, zout )
-      CALL histdef( nidtrd, "somlttax", clmxl//"T Zonal Advection", "C/s",       & ! i-adv.
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlttay", clmxl//"T Meridional Advection", "C/s",   & ! j-adv.
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlttaz", clmxl//"T Vertical Advection", "C/s",   & ! vert. adv.
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlttdh", clmxl//"T Horizontal Diffusion ", "C/s",   & ! hor. lateral diff.
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlttfo", clmxl//"T Forcing", "C/s",   & ! forcing
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlbtdz", clmxl//"T Vertical Diffusion", "C/s",   & ! vert. diff.
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlbtdt", clmxl//"T dh/dt Entrainment (Residual)", "C/s",   & ! T * dh/dt 
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zout, zout )
-      IF( ln_traldf_iso ) THEN
-      CALL histdef( nidtrd, "somlbtdv", clmxl//"T Vert. lateral Diffusion","C/s",   & ! vertical diffusion entrainment (ISO)
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      ENDIF
-#if defined key_traldf_eiv
-      CALL histdef( nidtrd, "somlgtax", clmxl//"T Zonal EIV Advection", "C/s",   & ! i-adv. (eiv)
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlgtay", clmxl//"T Meridional EIV Advection", "C/s",   & ! j-adv. (eiv)
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlgtaz", clmxl//"T Vertical EIV Advection", "C/s",   & ! vert. adv. (eiv)
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlgtat", clmxl//"T Total EIV Advection", "C/s",   & ! total advection (eiv)
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-#endif
-      ! Salinity
-      CALL histdef( nidtrd, "somlsalt", clmxl//"Salinity", "PSU",   & ! Mixed-layer salinity
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      ! Salinity trends
-      CALL histdef( nidtrd, "somltsto", clmxl//"S Total", "PSU/s",   & ! total 
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somltsax", clmxl//"S Zonal Advection", "PSU/s",   & ! i-advection
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somltsay", clmxl//"S Meridional Advection", "PSU/s",   & ! j-advection
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somltsaz", clmxl//"S Vertical Advection", "PSU/s",   & ! vertical advection
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somltsdh", clmxl//"S Horizontal Diffusion ", "PSU/s",   & ! hor. lat. diff.
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somltsfo", clmxl//"S Forcing", "PSU/s",   & ! forcing
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-
-      CALL histdef( nidtrd, "somlbsdz", clmxl//"S Vertical Diffusion", "PSU/s",   & ! vert. diff.
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlbsdt", clmxl//"S dh/dt Entrainment (Residual)", "PSU/s",   & ! S * dh/dt 
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      IF( ln_traldf_iso ) THEN
-      ! vertical diffusion entrainment (ISO)
-      CALL histdef( nidtrd, "somlbsdv", clmxl//"S Vertical lateral Diffusion", "PSU/s",   & ! vert. lat. diff.
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      ENDIF
-#if defined key_traldf_eiv
-      CALL histdef( nidtrd, "somlgsax", clmxl//"S Zonal EIV Advection", "PSU/s",   & ! i-advection (eiv)
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlgsay", clmxl//"S Meridional EIV Advection", "PSU/s",   & ! j-advection (eiv)
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlgsaz", clmxl//"S Vertical EIV Advection", "PSU/s",   & ! vert. adv. (eiv)
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-      CALL histdef( nidtrd, "somlgsat", clmxl//"S Total EIV Advection", "PSU/s",   & ! total adv. (eiv)
-         &          jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
-#endif
+      CALL histbeg( clhstnam, jpi, glamt, jpj, gphit,                                            &
+      &             1, jpi, 1, jpj, 0, zjulian, rdt, nh_t, nidtrd, domain_id=nidom )
+
+      !-- Define the ML depth variable
+      CALL histdef(nidtrd, "mxl_depth", clmxl//"  Mixed Layer Depth"              , "m",         &
+                   jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
+
+      !-- Define physical units
+      IF( ucf == 1. ) THEN
+         cltu = "degC/s"     ;   clsu = "p.s.u./s"
+      ELSEIF ( ucf == 3600.*24.) THEN
+         cltu = "degC/day"   ;   clsu = "p.s.u./day"
+      ELSE
+         cltu = "unknown?"   ;   clsu = "unknown?"
+      END IF
+
+      !-- Define miscellaneous T and S mixed-layer variables 
+
+      IF( jpltrd /= jpmld_atf ) CALL ctl_stop( 'Error : jpltrd /= jpmld_atf' ) ! see below
+
+      !................................. ( ML temperature ) ...................................
+
+      CALL histdef(nidtrd, "tml"      , clmxl//" T Mixed Layer Temperature"       ,  "C",        &
+                   jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )           
+      CALL histdef(nidtrd, "tml_tot",   clmxl//" T Total trend"                   , cltu,        & 
+                   jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zout, zout )              
+      CALL histdef(nidtrd, "tml_res",   clmxl//" T dh/dt Entrainment (Resid.)"    , cltu,        & 
+                   jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zout, zout )                   
+      
+      DO jl = 1, jpltrd - 1      ! <== only true if jpltrd == jpmld_atf
+         CALL histdef(nidtrd, trim("tml"//ctrd(jl,2)), clmxl//" T"//ctrd(jl,1), cltu,            & 
+                   jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout ) ! IOIPSL: time mean
+      END DO                                                                 ! if zsto=rdt above
+      
+      CALL histdef(nidtrd, trim("tml"//ctrd(jpmld_atf,2)), clmxl//" T"//ctrd(jpmld_atf,1), cltu, & 
+                   jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zout, zout ) ! IOIPSL: NO time mean
+      
+      !.................................. ( ML salinity ) .....................................
+     
+      CALL histdef(nidtrd, "sml"      , clmxl//" S Mixed Layer Salinity"          , "p.s.u.",       &
+                   jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout )           
+      CALL histdef(nidtrd, "sml_tot",   clmxl//" S Total trend"                   , clsu,        & 
+                   jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zout, zout )              
+      CALL histdef(nidtrd, "sml_res",   clmxl//" S dh/dt Entrainment (Resid.)"    , clsu,        & 
+                   jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zout, zout )                   
+      
+      DO jl = 1, jpltrd - 1      ! <== only true if jpltrd == jpmld_atf
+         CALL histdef(nidtrd, trim("sml"//ctrd(jl,2)), clmxl//" S"//ctrd(jl,1), clsu,            & 
+                   jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zsto, zout ) ! IOIPSL: time mean
+      END DO                                                                 ! if zsto=rdt above
+      
+      CALL histdef(nidtrd, trim("sml"//ctrd(jpmld_atf,2)), clmxl//" S"//ctrd(jpmld_atf,1), clsu, & 
+                   jpi, jpj, nh_t, 1  , 1, 1  , -99 , 32, clop, zout, zout ) ! IOIPSL: NO time mean
+
+      !-- Leave IOIPSL/NetCDF define mode
       CALL histend( nidtrd )
-#endif
-
-      IF( idebug /= 0 ) THEN
-         WRITE(numout,*) ' debuging trd_mld_init: II. done'  
-         CALL FLUSH(numout)
-      ENDIF
-
-
-      END SUBROUTINE trd_mld_init
+
+#endif        /* key_dimgout */
+   END SUBROUTINE trd_mld_init
 
 #else
@@ -856,5 +928,4 @@
    !!   Default option :                                       Empty module
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trdmld = .FALSE.   !: momentum trend flag
 CONTAINS
    SUBROUTINE trd_mld( kt )             ! Empty routine
Index: trunk/NEMO/OPA_SRC/TRD/trdmld_oce.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdmld_oce.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRD/trdmld_oce.F90	(revision 503)
@@ -4,27 +4,32 @@
    !! Ocean trends :   set tracer and momentum trend variables
    !!======================================================================
+   !! History :  9.0  !  04-08  (C. Talandier)  New trends organization
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
-   !! * Modules used
    USE par_oce         ! ocean parameters
 
    IMPLICIT NONE
-   PUBLIC
+   PRIVATE
 
-   INTEGER, PARAMETER ::            &  !: mixed layer trends index
-      jpmldxad = 1,   &  !: zonal advection
-      jpmldyad = 2,   &  !: meridionnal advection
-      jpmldzad = 3,   &  !: vertical advection
-      jpmldldf = 4,   &  !: lateral diffusion (horiz. component+Beckman)
-      jpmldfor = 5,   &  !: forcing 
-      jpmldevd = 6,   &  !: entrainment due to vertical diffusion (TKE)
-      jpmldzdf = 7,   &  !: explicit vertical part if isopycnal diffusion
-      jpmldxei = 8,   &  !: eddy induced zonal advection
-      jpmldyei = 9,   &  !: eddy induced meridional advection
-      jpmldzei =10       !: eddy induced vertical advection
+#if defined key_trdmld
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trdmld = .TRUE.    !: ML trend flag
+#else
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trdmld = .FALSE.   !: ML trend flag
+#endif
+   !!* mixed layer trends indices
+   INTEGER, PARAMETER, PUBLIC ::   jpltrd = 11    !: number of mixed-layer trends arrays
+   INTEGER, PARAMETER, PUBLIC ::   jpktrd = jpk   !: max level for mixed-layer trends diag.
+   !
+   INTEGER, PUBLIC, PARAMETER ::   jpmld_xad =  1   !:  zonal      \
+   INTEGER, PUBLIC, PARAMETER ::   jpmld_yad =  2   !:  meridonal   > advection
+   INTEGER, PUBLIC, PARAMETER ::   jpmld_zad =  3   !:  vertical   /
+   INTEGER, PUBLIC, PARAMETER ::   jpmld_ldf =  4   !:  lateral diffusion (geopot. or iso-neutral)
+   INTEGER, PUBLIC, PARAMETER ::   jpmld_for =  5   !:  forcing 
+   INTEGER, PUBLIC, PARAMETER ::   jpmld_zdf =  6   !:  vertical diffusion (TKE)
+   INTEGER, PUBLIC, PARAMETER ::   jpmld_bbc =  7   !:  geothermal flux
+   INTEGER, PUBLIC, PARAMETER ::   jpmld_bbl =  8   !:  bottom boundary layer (advective/diffusive)
+   INTEGER, PUBLIC, PARAMETER ::   jpmld_dmp =  9   !:  internal restoring trend
+   INTEGER, PUBLIC, PARAMETER ::   jpmld_npc = 10   !:  non penetrative convective adjustment
+   INTEGER, PUBLIC, PARAMETER ::   jpmld_atf = 11   !:  asselin trend
+!! INTEGER, PUBLIC, PARAMETER ::   jpmld_xxx = xx   !:  add here any additional trend (add change jpltrd)
 
 #if   defined  key_trdmld   ||   defined key_esopa
@@ -33,16 +38,48 @@
    !!----------------------------------------------------------------------
 
-   !! Trends diagnostics parameters
+   !! Arrays used for diagnosing mixed-layer trends 
    !!---------------------------------------------------------------------
-   INTEGER, PARAMETER ::            &  !:
-# if defined key_traldf_eiv
-      jpltrd = 10,  &  !: number of mixed-layer trends arrays
-      jpktrd = jpk     !: max level for mixed-layer trends diag.
-# else
-      jpltrd = 7,   &  !: number of mixed-layer trends arrays
-      jpktrd = jpk     !: max level for mixed-layer trends diag.
-# endif
+   CHARACTER(LEN=80) , PUBLIC :: clname, ctrd(jpltrd+1,2)
 
+   INTEGER , PUBLIC, DIMENSION(jpi,jpj)     ::   nmld   !: mixed layer depth indexes 
+   INTEGER , PUBLIC, DIMENSION(jpi,jpj)     ::   nbol   !: mixed-layer depth indexes when read from file
+
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   wkx    !:
+
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::  &
+      rmld   ,                      & !: mld depth (m) corresponding to nmld
+      tml    , sml  ,               & !: \ "now" mixed layer temperature/salinity
+      tmlb   , smlb ,               & !: /  and associated "before" fields
+      tmlbb  , smlbb,               & !: \  idem, but valid at the 1rst time step of the
+      tmlbn  , smlbn,               & !: /  current analysis window
+      tmltrdm, smltrdm,             & !: total cumulative trends over the analysis window
+      tml_sum,                      & !: mixed layer T, summed over the current analysis period
+      tml_sumb,                     & !: idem, but from the previous analysis period
+      tmltrd_atf_sumb,              & !: Asselin trends, summed over the previous analysis period
+      sml_sum,                      & !: 
+      sml_sumb,                     & !:    ( idem for salinity )
+      smltrd_atf_sumb,              & !: 
+      rmld_sum, rmldbn                !: needed to compute the leap-frog time mean of the ML depth
+
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::  &
+      tmlatfb, tmlatfn ,            & !: "before" Asselin contribution at begining of the averaging
+      smlatfb, smlatfn,             & !: period (i.e. last contrib. from previous such period) and 
+                                      !: "now" Asselin contribution to the ML temp. & salinity trends
+      tmlatfm, smlatfm                !: accumulator for Asselin trends (needed for storage only)
+
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpltrd) ::  &
+      tmltrd,                       & !: \ physical contributions to the total trend (for T/S),
+      smltrd,                       & !: / cumulated over the current analysis window
+      tmltrd_sum,                   & !: sum of these trends over the analysis period
+      tmltrd_csum_ln,               & !: now cumulated sum of the trends over the "lower triangle"
+      tmltrd_csum_ub,               & !: before (prev. analysis period) cumulated sum over the upper triangle
+      smltrd_sum,                   & !: 
+      smltrd_csum_ln,               & !:    ( idem for salinity )
+      smltrd_csum_ub                  !: 
 #endif
-  !!======================================================================
+   !!----------------------------------------------------------------------
+   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! $Header$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!======================================================================
 END MODULE trdmld_oce
